volatile static unsigned int *video = (unsigned int*) 0xCC002000;
volatile static unsigned long *Framebuffer = (unsigned long*)0xC0500000;

static const unsigned int VIDEO_Mode640X480NtscYUV16[32] = {
0x0F060001, 0x476901AD, 0x02EA5140, 0x00030018,
0x00020019, 0x410C410C, 0x40ED40ED, 0x00435A4E,
0x00000000, 0x00435A4E, 0x00000000, 0x00000000,
0x110701AE, 0x10010001, 0x00010001, 0x00010001,
0x00000000, 0x00000000, 0x28500100, 0x1AE771F0,
0x0DB4A574, 0x00C1188E, 0xC4C0CBE2, 0xFCECDECF,
0x13130F08, 0x00080C0F, 0x00FF0000, 0x00000000,
0x02800000, 0x000000FF, 0x00FF00FF, 0x00FF00FF};

static const unsigned int VIDEO_Mode640X480Pal50YUV16[32] = {
0x11F50101, 0x4B6A01B0, 0x02F85640, 0x00010023,
0x00000024, 0x4D2B4D6D, 0x4D8A4D4C, 0x00435A4E,
0x00000000, 0x00435A4E, 0x00000000, 0x013C0144,
0x113901B1, 0x10010001, 0x00010001, 0x00010001,
0x00000000, 0x00000000, 0x28500100, 0x1AE771F0,
0x0DB4A574, 0x00C1188E, 0xC4C0CBE2, 0xFCECDECF,
0x13130F08, 0x00080C0F, 0x00FF0000, 0x00000000,
0x02800000, 0x000000FF, 0x00FF00FF, 0x00FF00FF};

#define FRAMEBUFFERADDR 0xC0500000 /* in main RAM */

#define CLAMP(x,l,h) ((x > h) ? h : ((x < l) ? l : x))
// Software RGB to YCBCr conversion code for XFB programs.
unsigned long GC_Video_RGBToYCbCr (unsigned char r, unsigned char g, unsigned char b)
{
    float Y, Cb, Cr;

    Y  =  0.257 * (float)r + 0.504 * (float)g + 0.098 * (float)b +  16.0 + 0.5;
    Cb = -0.148 * (float)r - 0.291 * (float)g + 0.439 * (float)b + 128.0 + 0.5;
    Cr =  0.439 * (float)r - 0.368 * (float)g - 0.071 * (float)b + 128.0 + 0.5;

    Y  = CLAMP(Y , 16, 235);
    Cb = CLAMP(Cb, 16, 240);
    Cr = CLAMP(Cr, 16, 240);

    return (unsigned long)(((unsigned char)Y << 24) | ((unsigned char)Cb << 16) | ((unsigned char)Y << 8) | (unsigned char)Cr);
}

void print(int cx, int cy, char* text) {
    extern unsigned char font[];
    int x, y;
    char c;

    while (*text) {
        for (y = 0; y < 16; y++) {
	    for (x = 0; x < 8; x++) {
                if(font[(*text)*16+y] & (1<<(8-x))) c = 0xff; else c = 0;
	        Framebuffer[(cy*16+y)*640+(cx*8+x)] = GC_Video_RGBToYCbCr(c, c, c);
	    }
	}
	cx++;
	text++;
    }
}

int main() {
    int i;
    for(i=0; i<32; i++) {
      video[i] = VIDEO_Mode640X480NtscYUV16[i];
    }
    video[7] = FRAMEBUFFERADDR;
    video[9] = FRAMEBUFFERADDR;

    for (i = 0; i < 320*480; i++)
	    Framebuffer[i] = 0x00800080;

    extern unsigned char linux_logo[];
    extern unsigned char linux_logo_red[];
    extern unsigned char linux_logo_green[];
    extern unsigned char linux_logo_blue[];

    int x, y;
    unsigned char c, r, g, b;

    i = 0;
    for (y = 60; y < 140; y++) {
        for (x = 120; x < 200; x++) {
	    c = linux_logo[i] - 0x20;
	    i++;
	    r = linux_logo_red[c];
	    g = linux_logo_green[c];
	    b = linux_logo_blue[c];
	    Framebuffer[y*640+x] = GC_Video_RGBToYCbCr(r, g, b);
	    Framebuffer[y*640+x+320] = GC_Video_RGBToYCbCr(r, g, b);
	}
    }


    //print(14, 10, "Hello World!");
    print(6, 10, "Gamecube Linux - coming soon!");
    print(8, 11, "http://www.gc-linux.org/");


    while (1);
}
